Initial commit

This commit is contained in:
2024-10-30 01:50:38 +01:00
commit 587ca23374
147 changed files with 7521 additions and 0 deletions

View File

@@ -0,0 +1,4 @@
---
skip_list:
- fqcn
- name

View File

@@ -0,0 +1,16 @@
---
name: Release to Ansible Galaxy
on:
push:
branches: [master]
workflow_dispatch:
jobs:
galaxy:
runs-on: ubuntu-latest
steps:
- uses: robertdebock/galaxy-action@1.2.0
with:
galaxy_api_key: ${{secrets.galaxy_api_key}}
git_branch: master

3
roles/gekmihesg.openwrt/.gitignore vendored Normal file
View File

@@ -0,0 +1,3 @@
.*.swp
*.pyc
Pipfile*

View File

@@ -0,0 +1,9 @@
---
extends: default
rules:
line-length: disable
truthy: disable
comments-indentation: disable
# code: language=yaml tabSize=2

View File

@@ -0,0 +1,674 @@
GNU GENERAL PUBLIC LICENSE
Version 3, 29 June 2007
Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.
Preamble
The GNU General Public License is a free, copyleft license for
software and other kinds of works.
The licenses for most software and other practical works are designed
to take away your freedom to share and change the works. By contrast,
the GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users. We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors. You can apply it to
your programs, too.
When we speak of free software, we are referring to freedom, not
price. Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.
To protect your rights, we need to prevent others from denying you
these rights or asking you to surrender the rights. Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.
For example, if you distribute copies of such a program, whether
gratis or for a fee, you must pass on to the recipients the same
freedoms that you received. You must make sure that they, too, receive
or can get the source code. And you must show them these terms so they
know their rights.
Developers that use the GNU GPL protect your rights with two steps:
(1) assert copyright on the software, and (2) offer you this License
giving you legal permission to copy, distribute and/or modify it.
For the developers' and authors' protection, the GPL clearly explains
that there is no warranty for this free software. For both users' and
authors' sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.
Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so. This is fundamentally incompatible with the aim of
protecting users' freedom to change the software. The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable. Therefore, we
have designed this version of the GPL to prohibit the practice for those
products. If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.
Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary. To prevent this, the GPL assures that
patents cannot be used to render the program non-free.
The precise terms and conditions for copying, distribution and
modification follow.
TERMS AND CONDITIONS
0. Definitions.
"This License" refers to version 3 of the GNU General Public License.
"Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.
"The Program" refers to any copyrightable work licensed under this
License. Each licensee is addressed as "you". "Licensees" and
"recipients" may be individuals or organizations.
To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy. The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.
A "covered work" means either the unmodified Program or a work based
on the Program.
To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy. Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.
To "convey" a work means any kind of propagation that enables other
parties to make or receive copies. Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.
An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License. If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.
1. Source Code.
The "source code" for a work means the preferred form of the work
for making modifications to it. "Object code" means any non-source
form of a work.
A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.
The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form. A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.
The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities. However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work. For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.
The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.
The Corresponding Source for a work in source code form is that
same work.
2. Basic Permissions.
All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met. This License explicitly affirms your unlimited
permission to run the unmodified Program. The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work. This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.
You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force. You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright. Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.
Conveying under any other circumstances is permitted solely under
the conditions stated below. Sublicensing is not allowed; section 10
makes it unnecessary.
3. Protecting Users' Legal Rights From Anti-Circumvention Law.
No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.
When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.
4. Conveying Verbatim Copies.
You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.
You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.
5. Conveying Modified Source Versions.
You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:
a) The work must carry prominent notices stating that you modified
it, and giving a relevant date.
b) The work must carry prominent notices stating that it is
released under this License and any conditions added under section
7. This requirement modifies the requirement in section 4 to
"keep intact all notices".
c) You must license the entire work, as a whole, under this
License to anyone who comes into possession of a copy. This
License will therefore apply, along with any applicable section 7
additional terms, to the whole of the work, and all its parts,
regardless of how they are packaged. This License gives no
permission to license the work in any other way, but it does not
invalidate such permission if you have separately received it.
d) If the work has interactive user interfaces, each must display
Appropriate Legal Notices; however, if the Program has interactive
interfaces that do not display Appropriate Legal Notices, your
work need not make them do so.
A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit. Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.
6. Conveying Non-Source Forms.
You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:
a) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by the
Corresponding Source fixed on a durable physical medium
customarily used for software interchange.
b) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by a
written offer, valid for at least three years and valid for as
long as you offer spare parts or customer support for that product
model, to give anyone who possesses the object code either (1) a
copy of the Corresponding Source for all the software in the
product that is covered by this License, on a durable physical
medium customarily used for software interchange, for a price no
more than your reasonable cost of physically performing this
conveying of source, or (2) access to copy the
Corresponding Source from a network server at no charge.
c) Convey individual copies of the object code with a copy of the
written offer to provide the Corresponding Source. This
alternative is allowed only occasionally and noncommercially, and
only if you received the object code with such an offer, in accord
with subsection 6b.
d) Convey the object code by offering access from a designated
place (gratis or for a charge), and offer equivalent access to the
Corresponding Source in the same way through the same place at no
further charge. You need not require recipients to copy the
Corresponding Source along with the object code. If the place to
copy the object code is a network server, the Corresponding Source
may be on a different server (operated by you or a third party)
that supports equivalent copying facilities, provided you maintain
clear directions next to the object code saying where to find the
Corresponding Source. Regardless of what server hosts the
Corresponding Source, you remain obligated to ensure that it is
available for as long as needed to satisfy these requirements.
e) Convey the object code using peer-to-peer transmission, provided
you inform other peers where the object code and Corresponding
Source of the work are being offered to the general public at no
charge under subsection 6d.
A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.
A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling. In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage. For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product. A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.
"Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source. The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.
If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information. But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).
The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed. Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.
Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.
7. Additional Terms.
"Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law. If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.
When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it. (Additional permissions may be written to require their own
removal in certain cases when you modify the work.) You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.
Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:
a) Disclaiming warranty or limiting liability differently from the
terms of sections 15 and 16 of this License; or
b) Requiring preservation of specified reasonable legal notices or
author attributions in that material or in the Appropriate Legal
Notices displayed by works containing it; or
c) Prohibiting misrepresentation of the origin of that material, or
requiring that modified versions of such material be marked in
reasonable ways as different from the original version; or
d) Limiting the use for publicity purposes of names of licensors or
authors of the material; or
e) Declining to grant rights under trademark law for use of some
trade names, trademarks, or service marks; or
f) Requiring indemnification of licensors and authors of that
material by anyone who conveys the material (or modified versions of
it) with contractual assumptions of liability to the recipient, for
any liability that these contractual assumptions directly impose on
those licensors and authors.
All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10. If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term. If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.
If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.
Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.
8. Termination.
You may not propagate or modify a covered work except as expressly
provided under this License. Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).
However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.
Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.
Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License. If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.
9. Acceptance Not Required for Having Copies.
You are not required to accept this License in order to receive or
run a copy of the Program. Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance. However,
nothing other than this License grants you permission to propagate or
modify any covered work. These actions infringe copyright if you do
not accept this License. Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.
10. Automatic Licensing of Downstream Recipients.
Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License. You are not responsible
for enforcing compliance by third parties with this License.
An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations. If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.
You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License. For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.
11. Patents.
A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based. The
work thus licensed is called the contributor's "contributor version".
A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version. For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.
Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.
In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement). To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.
If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients. "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.
If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.
A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License. You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.
Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.
12. No Surrender of Others' Freedom.
If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License. If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all. For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.
13. Use with the GNU Affero General Public License.
Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU Affero General Public License into a single
combined work, and to convey the resulting work. The terms of this
License will continue to apply to the part which is the covered work,
but the special requirements of the GNU Affero General Public License,
section 13, concerning interaction through a network will apply to the
combination as such.
14. Revised Versions of this License.
The Free Software Foundation may publish revised and/or new versions of
the GNU General Public License from time to time. Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.
Each version is given a distinguishing version number. If the
Program specifies that a certain numbered version of the GNU General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation. If the Program does not specify a version number of the
GNU General Public License, you may choose any version ever published
by the Free Software Foundation.
If the Program specifies that a proxy can decide which future
versions of the GNU General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.
Later license versions may give you additional or different
permissions. However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.
15. Disclaimer of Warranty.
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
16. Limitation of Liability.
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.
17. Interpretation of Sections 15 and 16.
If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.
END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.
To do so, attach the following notices to the program. It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.
<one line to give the program's name and a brief idea of what it does.>
Copyright (C) <year> <name of author>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
Also add information on how to contact you by electronic and paper mail.
If the program does terminal interaction, make it output a short
notice like this when it starts in an interactive mode:
<program> Copyright (C) <year> <name of author>
This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
This is free software, and you are welcome to redistribute it
under certain conditions; type `show c' for details.
The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License. Of course, your program's commands
might be different; for a GUI interface, you would use an "about box".
You should also get your employer (if you work as a programmer) or school,
if any, to sign a "copyright disclaimer" for the program, if necessary.
For more information on this, and how to apply and follow the GNU GPL, see
<http://www.gnu.org/licenses/>.
The GNU General Public License does not permit incorporating your program
into proprietary programs. If your program is a subroutine library, you
may consider it more useful to permit linking proprietary applications with
the library. If this is what you want to do, use the GNU Lesser General
Public License instead of this License. But first, please read
<http://www.gnu.org/philosophy/why-not-lgpl.html>.

View File

@@ -0,0 +1,178 @@
Ansible Role: openwrt
=====================
Manage OpenWRT and derivatives with Ansible but without Python.
By putting a host in the inventory group `openwrt`, some modules are replaced with a shell version running on a standard OpenWRT installation, trying to preserve most of the original functionality. Hosts, that are not in this group are not affected. This makes it possible to have tasks mixed with OpenWRT and other platforms.
There are also some new, OpenWRT specific modules included (like `uci`).
**Not all argument combinations are tested!** Some cases have only been translated from Python for completeness' sake.
Currently, the following modules have been implemented:
* command
* copy
* fetch (implicit)
* file
* lineinfile
* nohup (new)
* opkg
* ping
* service
* setup
* shell (implicit)
* slurp
* stat
* sysctl
* template (implicit)
* uci (new)
* wait\_for\_connection (implicit)
To achieve all this, some monkey patching is involved (in case you wonder about the `vars_plugins`).
Compatibility
-------------
This role was tested successfully with:
* LEDE 17.01 (manually)
* OpenWRT 18.06
* OpenWRT 19.07
* OpenWRT 21.02
* OpenWRT 22.03
Requirements
------------
Some modules optionally require a way to generate SHA1 hashes or encode data Base64. In case of Base64, there is a very slow `hexdump | awk` implementation included. For SHA1 there is no workaround.
The modules will try to find usable system commands for SHA1 (`sha1sum`, `openssl`) and Base64 (`base64`, `openssl`, workaround) when needed. If no usable commands are found, most things will still work, but the fetch module for example has to be run with `validate_checksum: no`, will always download the file and return `changed: yes`.
Therefore it is recommended to install `coreutils-sha1sum` and `coreutils-base64`, if the commands are not already provided by busybox. The role does that automatically by default (see below).
Role Variables
--------------
openwrt_install_recommended_packages:
Checks for some commands and installs the corresponding packages if they are
missing. See requirements above. (default: yes)
openwrt_scp_if_ssh:
Whether to use scp instead of sftp for OpenWRT systems. Value can be `yes`,
`no` or `smart`. Ansible defaults to `smart` but this role defaults to `yes`
because OpenWRT does not offer sftp by default. (default: yes)
openwrt_remote_tmp:
Ansibles remote_tmp setting for OpenWRT systems. Defaults to /tmp to avoid
flash wear on target device. (default: /tmp)
openwrt_wait_for_connection, openwrt_wait_for_connection_timeout:
Whether to wait for the host (default: yes) and how long (300) after a
network or wifi restart (see handlers).
openwrt_ssh, openwrt_scp, openwrt_ssh_host, openwrt_ssh_user, openwrt_user_host:
Helper shortcuts to do things like
"command: {{ openwrt_scp }} {{ openwrt_user_host|quote }}:/etc/rc.local /tmp"
Example Playbook
----------------
Inventory:
```ini
[aps]
ap1.example.com
ap2.example.com
ap3.example.com
[routers]
router1.example.com
[openwrt:children]
aps
routers
```
Playbook:
```yaml
- hosts: openwrt
roles:
- gekmihesg.openwrt
tasks:
- name: copy openwrt image
command: "{{ openwrt_scp }} image.bin {{ openwrt_user_host|quote }}:/tmp/sysupgrade.bin"
delegate_to: localhost
- name: start sysupgrade
nohup:
command: sysupgrade -q /tmp/sysupgrade.bin
- name: wait for reboot
wait_for_connection:
timeout: 300
delay: 60
- name: install mdns
opkg:
name: mdns
state: present
- name: enable and start mdns
service:
name: mdns
state: started
enabled: yes
- name: copy authorized keys
copy:
src: authorized_keys
dest: /etc/dropbear/authorized_keys
- name: revert pending changes
uci:
command: revert
- name: configure wifi device radio0
uci:
command: set
key: wireless.radio0
value:
phy: phy0
type: mac80211
hwmode: 11g
channel: auto
- name: configure wifi interface
uci:
command: section
config: wireless
type: wifi-iface
find_by:
device: radio0
mode: ap
value:
ssid: MySSID
encryption: psk2+ccmp
key: very secret
- name: commit changes
uci:
command: commit
notify: reload wifi
```
Running the modules outside of a playbook is possible like this:
```bash
$ export ANSIBLE_LIBRARY=~/.ansible/roles/gekmihesg.openwrt/library
$ export ANSIBLE_VARS_PLUGINS=~/.ansible/roles/gekmihesg.openwrt/vars_plugins
$ ansible -i openwrt-hosts -m setup all
```
License
-------
GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
Developing
----------
Writing custom modules for this framework isn't to hard. The modules are wrapped into a wrapper script, that provides some common functions for parameter parsing, json handling, response generation, and some more.
All modules must match `openwrt_<module_name>.sh`. If module\_name is not one of Ansibles core modules, there must also be a `<module_name>.py`. This does not have to have any functionality (it may have some for non OpenWRT systems) and can contain the documentation.
Make sure to install the `requirements.txt` packages in your virtual environment and, with the venv activated, run:
```bash
$ molecule test
```
before commiting and submitting your PR.
Writing tests for your new module is also highly recommended.

View File

@@ -0,0 +1,17 @@
---
openwrt_install_recommended_packages: true
openwrt_wait_for_connection: true
openwrt_wait_for_connection_timeout: 600
openwrt_ssh: "{{ ansible_ssh_executable | default('ssh') }} {{ ansible_ssh_common_args | default('') }} {{ ansible_ssh_extra_args | default('') }}"
openwrt_scp: "{{ ansible_scp_executable | default('scp') }} {{ ansible_scp_common_args | default('') }} {{ ansible_scp_extra_args | default('') }}"
openwrt_ssh_host: "{{ ansible_host | default(ansible_ssh_host | default(inventory_hostname)) }}"
openwrt_ssh_user: "{{ ansible_user | default(ansible_ssh_user | default('root')) }}"
openwrt_scp_if_ssh: true
openwrt_ssh_transfer_method: "{{ 'smart' if openwrt_scp_if_ssh == 'smart' else openwrt_scp_if_ssh | ternary('scp', 'sftp') }}"
openwrt_ssh_use_tty: false
openwrt_remote_tmp: /tmp
openwrt_remote_opkg_lists_dir: /tmp/opkg-lists

View File

@@ -0,0 +1,356 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
[ $# -le 1 ] || { _script="$1"; shift; }
_params="$1"
. /usr/share/libubox/jshn.sh
_ANSIBLE_PARAMS="
_ansible_version/s _ansible_no_log/b _ansible_module_name/s
_ansible_syslog_facility/s _ansible_socket/s _ansible_verbosity/i
_ansible_diff/b _ansible_debug/b _ansible_check_mode/b
"
FILE_PARAMS="group/s mode/s owner/s follow/b"
CHANGED=""
FACT_VARS=""
JSON_PREFIX=""
MESSAGE=""
NO_EXIT_JSON=""
PARAMS=""
RESPONSE_VARS=""
SKIPPED=""
SUPPORTS_CHECK_MODE="1"
WANT_JSON=""
N="
"
T=" "
init() { :; }
main() { :; }
cleanup() { :; }
_exit_add_vars() {
local _var _name _type _always _value _IFS
for _var; do
_IFS="$IFS"; IFS="/"; set -- $_var; IFS="$_IFS"
_var="$1"; _type="$(_map_type "$2")"; _always="$3"
_IFS="$IFS"; IFS="="; set -- $_var; IFS="$_IFS"
_name="$1"; _var="${2:-$_name}"
eval "_value=\"\$$_var\""
[ -z "$_value" -a -z "$_always" ] ||
eval "json_add_$_type \"\$_name\" \"\$_value\""
done
}
_init_done=""
_exit() {
local _rc="$?"
local _v _k
[ -z "$_init_done" ] || cleanup "$_rc" || :
[ -z "$NO_EXIT_JSON" ] || return $_rc
json_set_namespace result
json_add_boolean changed $([ -z "$CHANGED" ]; echo $?)
json_add_boolean failed $([ $_rc -eq 0 ]; echo $?)
[ -z "$SKIPPED" ] || json_add_boolean skipped 1
[ -z "$MESSAGE" ] || json_add_string msg "$MESSAGE"
[ -z "$_init_done" ] || {
[ -z "$RESPONSE_VARS" ] || _exit_add_vars $RESPONSE_VARS
[ -z "$FACT_VARS" ] || {
json_add_object ansible_facts
_exit_add_vars "$FACT_VARS"
json_close_object
}
}
[ -z "$_ansible_diff" -o -z "$_diff_set" ] || {
json_add_object diff
json_add_string before "$_diff_before${_diff_before:+$N}"
json_add_string after "$_diff_after${_diff_after:+$N}"
[ -z "$_diff_before_header" ] ||
json_add_string before_header "$_diff_before_header"
[ -z "$_diff_after_header" ] ||
json_add_string after_header "$_diff_after_header"
json_close_object
}
echo; json_dump
json_cleanup
return $_rc
}
trap _exit EXIT
_map_type() {
[ -n "$1" ] || { echo "string"; return 0; }
case "$1" in
any) echo "any";;
s|str|string) echo "string";;
i|int|integer) echo "int";;
b|bool|boolean) echo "boolean";;
f|d|float|double) echo "double";;
l|a|list|array) echo "array";;
o|h|obj|object|hash|map) echo "object";;
*) fail "unknown type: $1";;
esac
}
_verify_value_type() {
local _value="$1"
local _type="$2"
case "$_type" in
int) printf "%d" "$_value" >/dev/null 2>&1 || return 1;;
double) printf "%f" "$_value" >/dev/null 2>&1 || return 1;;
boolean)
case "$_value" in
yes|true|True|1) _value="1";;
no|false|False|0) _value="";;
*) return 1;;
esac;;
esac
echo "$_value"
}
_parse_legacy_params() {
local _var _type _required _default _alias
local _param _value _IFS
for _param in $PARAMS; do
eval "${_param%%[/=]*}=\"\""
done
eval "$(cat "$_params")" || fail "could not parse params"
for _param in $PARAMS $_ANSIBLE_PARAMS; do
_value=""; _IFS="$IFS"; IFS="/"; set -- $_param; IFS="$_IFS"
_var="$1"; _type="$(_map_type "$2")"; _required="$3"; _default="$4"
_IFS="$IFS"; IFS="="; set -- $_var; IFS="$_IFS"; _var="$1"
for _alias; do
eval "_value=\"\$$_alias\""
[ -z "$_value" ] || break
done
eval "export -- _orig_$_var=\"\$_value\""
[ -z "$_value" ] && {
[ -z "$_required" ] || fail "$_var is required"
[ -z "$_default" ] ||
_value="$(_verify_value_type "$_default" "$_type")"
} || {
_value="$(_verify_value_type "$_value" "$_type")" ||
fail "$_var must be $_type"
}
eval "export -- $_var=\"\$_value\" _type_$_var=\"\$_type\""
done
return 0
}
_parse_json_params() {
local _var _type _required _default _alias
local _param _value _found _is_type _IFS
json_set_namespace params
json_load "$(cat -- "$_params")" || fail "could not parse params"
for _param in $PARAMS $_ANSIBLE_PARAMS; do
_value=""; _IFS="$IFS"; IFS="/"; set -- $_param; IFS="$_IFS"
_var="$1"; _type="$(_map_type "$2")"; _required="$3"; _default="$4"
_IFS="$IFS"; IFS="="; set -- $_var; IFS="$_IFS"; _var="$1"
_is_type=""; _found=""
for _alias; do
json_get_type _is_type "$_alias" &&
json_get_var _value "$_alias" ||
continue
_found="1"; break
done
eval "export -- _orig_$_var=\"\$_value\" _defined_$_var=\"$_found\""
[ -n "$_found" ] || {
[ -z "$_required" ] || fail "$_var is required"
[ -z "$_default" ] ||
_value="$(_verify_value_type "$_default" "$_type")"
}
case "$_is_type" in
array|object)
[ "$_type" = "$_is_type" -o "$_type" = "any" ] ||
fail "$_var must be $_type"
eval "export -- _type_${_var}=\"\$_is_type\""
json_add_string "_$_var" "$_alias";;
*)
[ -z "$_found" ] ||
_value="$(_verify_value_type "$_value" "$_type")" ||
fail "$_var must be $_type"
eval "export -- $_var=\"\$_value\" _type_$_var=\"\$_type\""
json_add_string "$_var" "$_value";;
esac
done
return 0
}
_parse_params() {
[ -n "$WANT_JSON" ] && _parse_json_params || _parse_legacy_params
}
_support_check_mode() {
[ -n "$_ansible_check_mode" -a -z "$SUPPORTS_CHECK_MODE" ] || return 0
SKIPPED="1"
MESSAGE="module does not support check mode"
exit 0
}
json_select_real() {
local real_var
json_get_var real_var "_$1"
json_select "$real_var"
}
changed() {
CHANGED="1"
}
fail() {
MESSAGE="$*"
exit 1
}
_result=""
try() {
[ $# -eq 1 ] && {
_result="$(eval "$1" 2>&1)" || fail "$*: $_result"
} || {
_result="$("$@" 2>&1)" || fail "$*: $_result"
}
}
final() {
try "$@"
exit 0
}
_diff_set=""
_diff_before=""
_diff_after=""
_diff_before_header=""
_diff_after_header=""
set_diff() {
_diff_before="${1:-$_diff_before}"
_diff_after="${2:-$_diff_after}"
_diff_before_header="${3:-$_diff_before_header}"
_diff_after_header="${4:-$_diff_after_header}"
_diff_set="1"
}
_get_file_attributes() {
local R="${2:+Ra}"
ls -l${R:-d} -- "$1" 2>/dev/null | md5
}
set_file_attributes() {
[ -z "$_ansible_check_mode" ] || return 0
[ "$mode" != "False" ] || mode=""
[ -n "$owner" -o -n "$group" -o -n "$mode" ] || return 0
local file="$1"
local R="${2:+-R }"
local result h
local before="$(_get_file_attributes "$@")"
! result="$(printf "%04o" "$mode" 2>/dev/null)" || mode="$result"
[ -z "$follow" ] && h="-h " || h=""
[ -z "$owner" ] || result="$(chown $h$R"$owner" -- "$file" 2>&1)" ||
fail "chown ($file) failed: $result"
[ -z "$group" ] || result="$(chgrp $h$R"$group" -- "$file" 2>&1)" ||
fail "chgrp ($file) failed: $result"
[ -z "$follow" -a -h "$file" ] ||
[ -z "$mode" ] || result="$(chmod $R"$mode" -- "$file" 2>&1)" ||
fail "chmod ($file) failed: $result"
[ "$before" = "$(_get_file_attributes "$@")" ] || changed
}
is_abs() {
[ "${1#/}" != "$1" ]
}
abspath() {
local dir="$(dirname -- "$1")"
local file="$(basename -- "$1")"
local P="${2:+ -P}"
[ -d "$dir" ] && dir="$(cd -- "$dir" && pwd$P)" ||
is_abs "$dir" || dir="$(pwd$P)/$dir"
echo "${dir:+$dir/}$file"
}
realpath() {
local f="$(abspath "$1" x)"
local tmp
while [ -h "$f" ]; do
tmp="$(readlink -- "$f")"
is_abs "$tmp" || tmp="$(dirname -- "$f")/$tmp"
f="$(abspath "$tmp" x)"
done
echo "$f"
}
backup_local() {
local src="$1"
local dest
[ ! -e "$src" ] || {
dest="$src.$$.$(date "+%Y-%m-%d@%H:%M:%S~")"
try cp -a -- "$src" "$dest"
echo "$dest"
}
}
dgst() {
local alg="$1"
local cmd checksum
shift
case "$alg" in
sha1|sha224|sha256|sha384|sha512|md5)
cmd="${alg}sum"
! type "$cmd" >/dev/null 2>&1 || {
checksum="$($cmd -- "$@")"
echo "${checksum%% *}"
return 0
}
! type openssl >/dev/null 2>&1 || {
checksum="$(openssl dgst -hex -$alg "$@")"
echo "${checksum##*= }"
return 0
}
return 1;;
*) fail "Unknown checksum algorithm '$alg'.";;
esac
}
md5() {
dgst md5 "$@"
}
base64() {
! which base64 >/dev/null 2>&1 ||
{ try command base64 "$1"; echo "$_result"; return 0; }
! type openssl >/dev/null 2>&1 ||
{ try openssl base64 -in "$1"; echo "$_result"; return 0; }
hexdump -e '16/1 "%02x" "\n"' -- "$1" | awk '
BEGIN { b64="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/" }
{ for(c=1; c<=length($0); c++) {
d=index("0123456789abcdef",substr($0,c,1));
if(d--) {
for(b=1; b<=4; b++) {
o=o*2+int(d/8); d=(d*2)%16;
if(!(++obc%6)) {
line=line""substr(b64,o+1,1); o=0;
if(++rc>75) { print line; line=""; rc=0; }
}
}
}
} }
END {
if(obc%6) {
while(obc++%6) { o=o*2; }
line=line""substr(b64,o+1,1);
}
while(obc%8||obc%6) { if(!(++obc%6)) { line=line"="; } }
print line;
}
'
}
json_set_namespace result
json_init
. "$_script"
_parse_params
_support_check_mode
init || fail "module init failed"
_init_done="1"
main

View File

@@ -0,0 +1,30 @@
---
- name: setup wifi
nohup:
command: /sbin/wifi
delay: 1
when: "'openwrt' in group_names"
- name: reload wifi
nohup:
command: /sbin/wifi reload
delay: 1
when: "'openwrt' in group_names"
- name: restart network
nohup:
command: /etc/init.d/network restart
delay: 1
when: "'openwrt' in group_names"
- name: wait for connection
wait_for_connection:
timeout: "{{ openwrt_wait_for_connection_timeout }}"
delay: 5
when:
- "'openwrt' in group_names"
- openwrt_wait_for_connection
listen:
- setup wifi
- reload wifi
- restart network

View File

@@ -0,0 +1,36 @@
#!/usr/bin/python
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
ANSIBLE_METADATA = {
'metadata_version': '1.0',
'status': ['preview'],
'supported_by': '@gekmihesg'
}
DOCUMENTATION = '''
---
module: nohup
short_description: Starts a command in background and returns
description:
- The M(nohup) module start runs a command in a shell using OpenWRTs C(start-stop-daemon).
- The module will dispatch the command and return.
author: Markus Weippert (@gekmihesg)
options:
command:
description:
- command to execute. Execution takes place in a shell.
required: true
aliases:
- cmd
delay:
description:
- seconds to wait, before command is run.
default: 0
note:
- This module does not support check_mode.
'''
EXAMPLES = '''
- name: wait 3 seconds, then restart network
nohup:
command: /etc/init.d/network restart
delay: 3
'''

View File

@@ -0,0 +1,63 @@
#!/bin/sh
# Copyright (c) 2021 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
cmd=raw_params=_raw_params/str/r
uses_shell=_uses_shell/bool//false
chdir/str
executable/str
creates/str
removes/str
"
RESPONSE_VARS="
start end delta cmd
stdout/str/a stderr/str/a rc/int/a
"
SUPPORTS_CHECK_MODE=""
init() {
stdout=""
stderr=""
start=""
end=""
delta=""
rc="0"
[ -n "$executable" ] || executable="/bin/sh"
out="$(mktemp)" && err="$(mktemp)"
}
main() {
local ts_start ts_end s_delta
[ -z "$chdir" ] || try cd "$chdir"
[ -z "$creates" ] || ! ls -d -- $creates >/dev/null 2>/dev/null || {
stdout="skipped, since $creates exists"; exit 0
}
[ -z "$removes" ] || ls -d -- $removes >/dev/null 2>/dev/null || {
stdout="skipped, since $removes does not exist"; exit 0
}
ts_start="$(date +%s)"
[ -z "$uses_shell" ] && {
echo "$cmd" | xargs sh -c 'exec "$@"' -- >"$out" 2>"$err"; rc=$?; :
} || {
"$executable" -c "$cmd" >"$out" 2>"$err"; rc=$?; :
}
ts_end="$(date +%s)"
s_delta=$((ts_end - ts_start))
start="$(date -d "@$ts_start" "+%Y-%m-%d %H:%M:%S").000000"
end="$(date -d "@$ts_end" "+%Y-%m-%d %H:%M:%S").000000"
delta="$(printf "%d:%.2d:%.2d.000000" \
$((delta / 3600)) $((delta % 3600 / 60)) $((delta % 60)))"
stdout="$(cat "$out")"
stderr="$(cat "$err")"
changed
test "$rc" -eq 0 || fail "non-zero return code"
return 0
}
cleanup() {
rm -f -- "$out" "$err"
}

View File

@@ -0,0 +1,83 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
backup/bool
dest/str/r
directory_mode/str
force=thirsty/bool//true
original_basename=_original_basename/str
src/str
validate/str
$FILE_PARAMS
"
RESPONSE_VARS="src dest md5sum=md5sum_src checksum backup_file"
init() {
md5sum_src=""
checksum=""
backup_file=""
}
main() {
local tmp _IFS
[ -e "$src" ] || fail "Source $src not found"
[ -r "$src" ] || fail "Source $src not readable"
[ ! -d "$src" ] || fail "Remote copy does not support recursive copy of directory: $src"
checksum_src="$(dgst sha1 "$src")" || :
md5sum_src="$(md5 "$src")"
md5sum_dest=""
[ -z "$original_basename" -o "${dest%/}" = "$dest" ] || {
dest="$dest/$original_basename"
tmp="$(dirname -- "$dest")"
[ -d "$tmp" ] || {
_IFS="$IFS"; IFS="/"; set -- $tmp; IFS="$_IFS"
tmp="$mode"; mode="$directory_mode"
local d
local p=""
for d; do
[ -n "$d" ] || continue
p="$p/$d"
[ ! -d "$p" ] || continue
try mkdir "$p"
set_file_attributes "$p"
done
mode="$tmp"
}
}
[ ! -d "$dest" ] || {
dest="${dest%/}"
[ -z "$original_basename" ] &&
dest="$dest/$(basename -- "$src")" ||
dest="$dest/$original_basename"
}
tmp="$(dirname -- "$dest")"
[ -e "$dest" ] && {
[ ! -h "$dest" -o -z "$follow" ] || dest="$(realpath "$dest")"
[ -n "$force" ] || fail "file already exists"
[ ! -r "$dest" ] || md5sum_dest="$(md5 "$dest")"
} || [ -d "$tmp" ] || fail "Destination directory $tmp does not exist"
[ -w "$tmp" ] || fail "Destination $tmp not writeable"
[ "$md5sum_src" = "$md5sum_dest" -a ! -h "$dest" ] || {
[ -n "$_ansible_check_mode" ] || {
[ -z "$backup" ] || backup_file="$(backup_local "$dest")"
[ ! -h "$dest" ] || { rm -f -- "$dest"; touch -- "$dest"; }
[ -z "$validate" ] || {
[ "${validate/%s/}" != "$validate" ] ||
fail "validate must contain %s: $validate"
tmp="$($(printf "$validate" "$src") 2>&1)" ||
fail "failed to validate: $tmp"
}
try 'cat -- "$src" > "$dest"'
}
changed
}
[ -n "$_ansible_check_mode" ] || set_file_attributes "$dest"
}

View File

@@ -0,0 +1,172 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
diff_peek/str
force/bool//false
original_basename=_original_basename/str
path=dest=name/str/r
recurse/bool//false
src/str
state/str
$FILE_PARAMS
"
RESPONSE_VARS="state path appears_binary/bool"
init() {
appears_binary=""
}
get_state() {
local state
state="$(ls -ld -- "$1" 2>/dev/null)" && {
case "${state:0:1}" in
l) state="link";;
d) state="directory";;
*) set -- $state; [ "$2" -gt 1 ] &&
state="hard" || state="file";;
esac
echo "$state"
} || { echo "absent"; }
}
get_inode() {
set -- $(ls -id -- "$1")
echo "$1"
}
main() {
[ -z "$diff_peek" ] || {
appears_binary="0"
hexdump -e '16/1 " %02x" " \n"' -c 8192 -- "$path" 2>/dev/null |
grep -q " 00 " && appears_binary="1" || :
exit 0
}
prev_state="$(get_state "$path")"
[ -n "$state" ] ||
case "$prev_state" in
absent) [ -z "$recurse" ] && state="file" || state="directory";;
*) state="$prev_state";;
esac
[ -n "$src" -o "$state" != "link" -a "$state" != "hard" ] || {
[ "$state" != "link" -o -z "$follow" ] ||
fail "src and dest are required for creating links"
src="$(realpath "$path")"
}
[ "$state" = "link" -o "$state" = "absent" -o ! -d "$path" ] || {
basename="$original_basename"
[ -n "$basename" -o -z "$src" ] || basename="$(basename -- "$src")"
[ -z "$basename" ] || {
path="${path%/}/$basename"
prev_state="$(get_state "$path")"
}
}
[ -z "$recurse" -o "$state" = "directory" ] ||
fail "recurse options requires state to be directory"
[ "$state" = "$prev_state" ] && state_change="" || state_change="y"
case "$state" in
absent)
[ ! -e "$path" ] || changed
[ -n "$_ansible_check_mode" ] ||
result="$(rm -rf -- "$path" 2>&1)" ||
fail "removing failed: $result";;
file)
[ -z "$state_change" -o -z "$follow" -o "$prev_state" != "link" ] || {
path="$(realpath "$path")"
prev_state="$(get_state "$path")"
}
[ "$prev_state" = "file" -o "$prev_state" = "hard" ] ||
fail "file ($path) is $prev_state, cannot continue"
set_file_attributes "$path";;
directory)
[ -z "$follow" -o "$prev_state" != "link" ] || {
path="$(realpath "$path")"
prev_state="$(get_state "$path")"
}
[ -e "$path" ] || changed
case "$prev_state" in
absent)
[ -n "$_ansible_check_mode" ] || {
oIFS="$IFS"; IFS="/"; set -- $path; IFS="$oIFS"
path=""
for p; do
[ -n "$p" ] || continue
path="$path/$p"
[ ! -e "$path" ] || continue
result="$(mkdir -p -- "$path" 2>&1)" ||
fail "error creating $path: $result"
changed
set_file_attributes "$path"
done
};;
directory) set_file_attributes "$path" "$recurse";;
*) fail "$path already exists as a $prev_state";;
esac;;
link|hard)
is_abs "$src" && abssrc="$src" || {
[ ! -h "$path" -a -d "$path" ] && abs="$path/$src" ||
abssrc="$(dirname "$path")/$src"
}
[ -e "$abssrc" ] && {
[ ! -d "$abssrc" -o "$state" != "hard" ] ||
fail "src is a directory, cannot hard link $abssrc"
} || {
[ "$state" != "hard" ] ||
fail "src file does not exist, cannot hard link $abssrc"
[ -n "$force" ] ||
fail "src file does not exist, use force=yes if you want to link $abssrc"
}
if [ "$prev_state" = "absent" ]; then
changed
elif [ "$prev_state" != "$state" -a -z "$force" ]; then
fail "refusing to convert between $prev_state and $state for $path"
elif [ "$prev_state" = "link" ]; then
[ "$state" = "link" -a "$(readlink "$path")" = "$src" ] ||
changed
elif [ "$prev_state" = "hard" ]; then
[ "$state" = "hard" -a "$(get_inode "$path")" = "$(get_inode "$abssrc")" ] || {
[ -n "$force" ] ||
fail "cannot link, different hard link exists at destination"
changed
}
elif [ "$prev_state" = "directory" ]; then
[ -z "$(find "$path" -mindepth 1 -maxdepth 1 2>/dev/null)" ] ||
fail "the directory $path is not empty refusing to convert it"
changed
else
changed
fi
[ -n "$_ansible_check_mode" ] || {
[ -z "$CHANGED" ] || {
[ "$state" = "hard" ] && flags="" || flags="-s"
[ "$prev_state" = "absent" ] ||
result="$(rm -rf -- "$path" 2>&1)" ||
fail "error replacing $path: $result"
result="$(ln $flags -- "$src" "$path" 2>&1)" ||
fail "error while linking $path to $src: $result"
}
set_file_attributes "$path"
};;
touch)
[ -n "$follow" -a "$prev_state" = "link" ] || {
path="$(realpath "$path")"
[ -n "$_ansible_check_mode" ] || {
result="$(touch -- "$path" 2>&1)" ||
fail "error touching $path: $result"
set_file_attributes "$path"
}
changed
};;
esac
}

View File

@@ -0,0 +1,122 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
backrefs/bool//false
create/bool//false
insertafter/str
insertbefore/str
line=value/str
path=dest=destfile=name/str/r
regex=regexp/str
state/str//present
$FILE_PARAMS
"
RESPONSE_VARS=""
escape_slash() {
echo "$1" | sed -e 's|^/|\\/|;:a;s|\([^\]\(\\\\\)*\)/|\1\\/|g;ta;q'
}
escape_chars() {
echo "$1" | sed 's|['"${2:-}"'\]|\\&|g;q'
}
get_last_match() {
echo "$2" | sed -nre "/$1/=" | sed '$!d'
}
save_changes() {
[ -n "$_ansible_check_mode" -o -z "$CHANGED" ] ||
echo "$1" > "$path" 2>/dev/null ||
fail "path $path not writeable"
}
line_present() {
local index old new mode tmp
[ -f "$path" ] && {
old="$(cat "$path")" || fail "path $path not readable"
} || {
[ -n "$create" ] || fail "path $path does not exist"
[ -n "$_ansible_check_mode" ] ||
mkdir -p "$(dirname "$path")"
old=""
}
index="$(get_last_match "$line_match" "$old")"
[ -n "$index" ] && {
tmp="$(echo "$old" | sed -n "${index}{p;q}")"
[ -z "$backrefs" ] || line="$(echo "$tmp" |
sed -re "s/$line_match/$(escape_slash "$line")/")"
[ "$tmp" = "$line" ] || {
new="$(echo "$old" | sed "${index}c $(escape_chars "$line" |
sed 's|^\s|\\&|;q')")"
changed
}
} || [ -n "$backrefs" ] || {
[ -n "${insertafter#[EB]OF}" ] && {
index="$(get_last_match "$(escape_slash "$insertafter")" "$old")"
mode="a"
} || [ -z "${insertbefore#BOF}" ] || {
index="$(get_last_match "$(escape_slash "$insertbefore")" "$old")"
mode="i"
}
[ -n "$index" ] && {
new="$(echo "$old" | sed "$index$mode $(escape_chars "$line" |
sed 's|^\s|\\&|;q')")"
} || {
[ "$insertafter" = "BOF" -o "$insertbefore" = "BOF" ] &&
new="$line$N$old" || {
tmp="$(echo "$old" | sed '${/^$/d}')"
new="$tmp${tmp:+$N}$line"
}
}
changed
}
[ -z "$CHANGED" ] || {
[ -z "$_ansible_diff" ] || set_diff "$old" "$new" "$path" "$path"
[ -n "$_ansible_check_mode" ] || save_changes "$new"
}
}
line_absent() {
local index new old
[ -f "$path" ] || return 0
old="$(cat "$path")" || fail "path $path not readable"
index="$(get_last_match "$line_match" "$old")"
[ -z "$index" ] || {
new="$(echo "$old" | sed -re "/$line_match/d")"
changed
}
[ -z "$_ansible_diff" ] || set_diff "$old" "$new" "$path" "$path"
[ -n "$_ansible_check_mode" -o -z "$CHANGED" ] || save_changes "$new"
}
main() {
case "$state" in
absent|present) :;;
*) fail "state must be absent or present";;
esac
[ -n "$regex" ] &&
line_match="$(escape_slash "$regex")" ||
line_match="^$(escape_chars "$line" '/.[*^$()+?{|')\$"
[ ! -d "$file" ] || fail "path $path is a directory"
case "$state" in
present)
[ -z "$backrefs" -o -n "$regex" ] ||
fail "regexp is required with backrefs"
[ -n "$line" ] || fail "line is required with state present"
line_present;;
absent)
[ -n "$line" -o -n "$regex" ] ||
fail "line or regexp is required with state absent"
line_absent;;
esac
set_file_attributes "$path" "" "y"
}

View File

@@ -0,0 +1,12 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="command=cmd/str/r delay/int//0"
SUPPORTS_CHECK_MODE=""
main() {
try /sbin/start-stop-daemon -Sbqp /dev/null -x /bin/sh -- -c \
"sleep $delay; $command"
changed
}

View File

@@ -0,0 +1,70 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
name=pkg/str/r
state/str//present
force/str
update_cache/bool
autoremove/bool
nodeps/bool
"
query_package() {
[ -n "$(opkg status "$1")" ]
}
install_packages() {
local _IFS pkg
_IFS="$IFS"; IFS=","; set -- $name; IFS="$_IFS"
for pkg; do
! query_package "$pkg" || continue
[ -n "$_ansible_check_mode" ] || {
try opkg install$force $nodeps "$pkg"
query_package "$pkg" || fail "failed to install $pkg: $_result"
}
changed
done
}
remove_packages() {
local _IFS pkg
_IFS="$IFS"; IFS=","; set -- $name; IFS="$_IFS"
for pkg; do
query_package "$pkg" || continue
[ -n "$_ansible_check_mode" ] || {
try opkg remove$force $autoremove $nodeps "$pkg"
! query_package "$pkg" || fail "failed to remove $pkg: $_result"
}
changed
done
}
main() {
case "$state" in
present|installed|absent|removed) :;;
*) fail "state must be present or absent";;
esac
[ -z "$force" ] || {
case "$force" in
depends|maintainer|reinstall|overwrite|downgrade|space) :;;
postinstall|remove|checksum|removal-of-dependent-packages) :;;
*) fail "unknown force option";;
esac
force=" --force-$force"
}
[ -z "$autoremove" ] || {
autoremove=" --autoremove"
}
[ -z "$nodeps" ] || {
nodeps=" --nodeps"
}
[ -z "$update_cache" -o -n "$_ansible_check_mode" ] || try opkg update
case "$state" in
present|installed) install_packages;;
absent|removed) remove_packages;;
esac
}

View File

@@ -0,0 +1,25 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="data/any"
RESPONSE_VARS="ping data"
__exit() {
[ -z "$NO_EXIT_JSON" ] || return $?
echo -n "{\"ping\":\"$ping\""
[ -z "$data" ] || echo -n ",\"data\":\"${data//\"/\\\"}\""
echo "}"
}
main() {
[ "$data" != "crash" ] ||
{ NO_EXIT_JSON="y"; echo "boom"; exit 1; }
ping="pong"
}
[ -n "$_ANSIBLE_PARAMS" ] || {
. "$1"
trap __exit EXIT
main
}

View File

@@ -0,0 +1,63 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
enabled/bool
name/str/r
pattern/str
state/str
"
RESPONSE_VARS="name enabled state"
is_running() {
[ -z "$pattern" ] || { pgrep -f "$pattern" >/dev/null 2>&1; return $?; }
"$init_script" running >/dev/null 2>&1
}
is_enabled() {
! "$init_script" enabled >/dev/null 2>&1 || echo 1
}
set_enabled() {
local status result
status="$(is_enabled)"
[ "$enabled" = "$status" ] || {
changed
[ -n "$_ansible_check_mode" ] || {
[ -n "$enabled" ] && action="enable" || action="disable"
result="$("$init_script" "$action" 2>&1)"
status="$(is_enabled)"
[ "$enabled" = "$status" ] ||
fail "Unable to $action service $name: $result"
}
}
case "$status" in
1) enabled="yes";;
*) enabled="no";;
esac
}
set_state() {
local action result running
is_running && running="y" || running=""
case "$state" in
started) [ -n "$running" ] || action="start";;
stopped) [ -z "$running" ] || action="stop";;
restarted|reloaded) action="${state%ed}";;
*) fail "Unknown action $action";;
esac
[ -z "$action" ] || {
changed
[ -n "$_ansible_check_mode" ] ||
result="$("$init_script" "$action" 2>&1)" ||
fail "Unable to $action service $name: $result"
}
}
main() {
init_script="/etc/init.d/$name"
[ -f "$init_script" ] || fail "service $name does not exist"
[ -z "$_orig_enabled" ] || set_enabled
[ -z "$state" ] || set_state
}

View File

@@ -0,0 +1,67 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
NO_EXIT_JSON="1"
add_ubus_fact() {
set -- ${1//!/ }
ubus list "$2" > /dev/null 2>&1 || return
local json="$($ubus call "$2" "$3" 2>/dev/null)"
echo -n "$seperator\"$1\":$json"
seperator=","
}
main() {
ubus="/bin/ubus"
seperator=","
echo '{"changed":false,"ansible_facts":'
dist="OpenWRT"
dist_version="NA"
dist_release="NA"
test -f /etc/openwrt_release && {
. /etc/openwrt_release
dist="${DISTRIB_ID:-$dist}"
dist_version="${DISTRIB_RELEASE:-$dist_version}"
dist_release="${DISTRIB_CODENAME:-$dist_release}"
} || test ! -f /etc/os-release || {
. /etc/os-release
dist="${NAME:-$dist}"
dist_version="${VERSION_ID:-$dist_version}"
}
dist_major="${dist_version%%.*}"
json_set_namespace facts
json_init
json_add_string ansible_hostname "$(cat /proc/sys/kernel/hostname)"
json_add_string ansible_distribution "$dist"
json_add_string ansible_distribution_major_version "$dist_major"
json_add_string ansible_distribution_release "$dist_release"
json_add_string ansible_distribution_version "$dist_version"
json_add_string ansible_os_family OpenWRT
json_add_boolean ansible_is_chroot "$([ -r /proc/1/root/. ] &&
{ [ / -ef /proc/1/root/. ]; echo $?; } ||
{ [ "$(ls -di / | awk '{print $1}')" -eq 2 ]; echo $?; }
)"
dist_facts="$(json_dump)"
json_cleanup
json_set_namespace result
echo "${dist_facts%\}*}"
for fact in \
info!system!info \
devices!network.device!status \
services!service!list \
board!system!board \
wireless!network.wireless!status \
; do
add_ubus_fact "openwrt_$fact"
done
echo "$seperator"'"openwrt_interfaces":{'
seperator=""
for net in $($ubus list); do
[ "${net#network.interface.}" = "$net" ] ||
add_ubus_fact "${net##*.}!$net!status"
done
echo '}}}'
}
[ -n "$_ANSIBLE_PARAMS" ] || main

View File

@@ -0,0 +1,21 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
src=path/str/r
"
RESPONSE_VARS="source=src content encoding"
init() {
content=""
encoding=""
}
main() {
[ -e "$src" ] || fail "file not found: $src"
[ -r "$src" ] || fail "file not readable: $src"
try base64 "$src"
content="$_result"
encoding="base64"
}

View File

@@ -0,0 +1,137 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
checksum_algorithm=checksum_algo=checksum/str//sha1
get_checksum/bool//true
get_md5/bool//true
get_mime/bool//true
path/str/r
"
RESPONSE_VARS="
charset/str
checksum/str
ctime/int
dev/int
executable/bool
exists/bool
gid/int
gr_name/str
inode/int
isblk/bool
ischr/bool
isdir/bool
isfifo/bool
isgid/bool
islnk/bool
isreg/bool
issock/bool
isuid/bool
lnk_source/str
md5/str
mime_type/str
mode/str
mtime/int
nlink/int
pw_name/str
readable/bool
rgrp/bool
roth/bool
rusr/bool
size/int
uid/int
wgrp/bool
woth/bool
writeable/bool
wusr/bool
xgrp/bool
xoth/bool
xusr/bool
"
init() {
local var
for var in $RESPONSE_VARS; do eval "${var%%/*}=\"\""; done
RESPONSE_VARS="path/str $RESPONSE_VARS"
}
parse_priv() {
local priv="$1"
local part="$2"
local octal="0"
[ -z "${priv#-??}" ] || { eval "r$part=\"1\""; octal=$((octal + 4)); }
[ -z "${priv#?-?}" ] || { eval "w$part=\"1\""; octal=$((octal + 2)); }
[ -z "${priv#??[-ST]}" ] || { eval "x$part=\"1\""; octal=$((octal + 1)); }
mode="$mode$octal"
[ -z "${priv#??[-x]}" ] || high=$((high + high_mod))
high_mod=$((high_mod / 2))
}
main() {
local var privs _IFS tmp
[ ! -h "$path" -o -z "$follow" ] || {
lnk_source="$path"
path="$(readlink -f "$path")" || :
}
[ -n "$path" -a -e "$path" -o -h "$path" ] || {
exists="0"
return 0
}
for var in $RESPONSE_VARS; do
_IFS="$IFS"; IFS="/"; set -- $var; IFS="$_IFS"
[ "${2#b}" = "$2" ] || eval "$1=\"0\""
done
exists="1"
charset="unknown"
mime_type="unknown"
set -- $(ls -lid "$path")
inode="$1"
privs="$2"
nlink="$3"
pw_name="$4"
gr_name="$5"
size="$6"
set -- $(ls -lidn "$path")
uid="$4"
gid="$5"
[ ! -x "$path" ] || executable="1"
[ ! -r "$path" ] || readable="1"
[ ! -w "$path" ] || writeable="1"
case "$privs" in
d*) isdir="1";;
l*) islnk="1";;
s*) issock="1";;
c*) ischr="1";;
b*) isblk="1";;
p*) isfifo="1";;
-*)
[ "$readable" != "1" ] || {
[ -z "$get_md5" ] || md5="$(md5 "$path")"
[ -z "$get_checksum" ] ||
checksum="$(dgst "$checksum_algorithm" "$path")" ||
[ "$checksum_algorithm" = "sha1" ] ||
fail "Could not hash file '$path' with algorithm '$checksum_algorithm'."
}
isreg="1";;
esac
mtime="$(date -r "$path" +%s)"
ctime="$mtime"
atime="$mtime"
[ "$(id -u)" -ne "$uid" ] || isuid="1"
[ "$(id -g)" -ne "$gid" ] || isgid="1"
high="0"; high_mod=4
privs="${privs#?}"; parse_priv "${privs%??????}" usr
privs="${privs#???}"; parse_priv "${privs%???}" grp
privs="${privs#???}"; parse_priv "$privs" oth
mode="$high$mode"
}
cleanup() {
json_set_namespace result
json_add_object stat
_exit_add_vars $RESPONSE_VARS
json_close_object
json_set_namespace params
RESPONSE_VARS=""
}

View File

@@ -0,0 +1,90 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
PARAMS="
ignore_errors=ignoreerrors/bool
name=key/str/r
reload/bool//true
state/str//present
sysctl_file/str
sysctl_set/bool//false
value=val/str
"
RESPONSE_VARS="name value"
init() {
sysctl="/sbin/sysctl"
default_sysctl_file="/etc/sysctl.conf"
tmp_file=""
}
sysctl_set() {
local result
[ "$(echo $($sysctl -n "$name"))" = "$value" ] || {
changed
[ -n "$_ansible_check_mode" ] ||
result="$($sysctl -w "$name=$value" 2>/dev/null)" ||
fail "failed to set $name to $value: $result"
}
}
sysctl_write() {
local found line v k
tmp_file="$(mktemp)"
while read line; do
set -- $line
[ -z "$1" -o "${1:0:1}" = "#" -o "${1/=/}" = "$1" ] || {
k="${1%%=*}"
[ "$k" != "$name" ] || {
found="1"
[ "$state" = "present" ] || { changed; continue; }
v="${1#*=}"
shift; while [ $# -ge 1 ]; do
[ "${1:0:1}" != "#" ] || break; v="$v $1"; shift
done
[ "$v" = "$value" ] || {
line="$k=$value${1:+ $*}"
changed
}
}
}
echo "$line" >> "$tmp_file"
done < "$sysctl_file"
[ "$state" != "present" -o -n "$found" ] || {
echo "$name=$value" >> "$tmp_file"
changed
}
}
main() {
local result
[ -n "$sysctl_file" ] || sysctl_file="$default_sysctl_file"
case "$state" in
absent) :;;
present)
[ -n "$value" ] ||
fail "value must be given with state present";;
*) fail "state must be present or absent";;
esac
[ -w "$sysctl_file" ] || fail "sysctl file $sysctl_file not writeable"
[ "$state" = "present" ] || ignore_errors="y"
[ -n "$ignore_errors" -a -z "$sysctl_set" ] ||
[ $($sysctl "$name" 2>/dev/null | wc -l) -eq 1 ] ||
fail "unknown sysctl key $name"
[ -z "$sysctl_set" ] || sysctl_set
sysctl_write
[ -z "$CHANGED" -o -n "$_ansible_check_mode" ] || {
cat "$tmp_file" > "$sysctl_file"
[ -z "$reload" -o "$state" != "present" ] ||
result="$($sysctl -p "$sysctl_file" 2>&1)" ||
fail "failed to reload: $result"
}
}
cleanup() {
[ -z "$tmp_file" ] || rm -f "$tmp_file"
}

View File

@@ -0,0 +1,384 @@
#!/bin/sh
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
WANT_JSON="1"
PARAMS="
autocommit/bool
command=cmd/str
config/str
find=find_by=search/any
keep_keys=keep/any
key/str
merge/bool//false
name/str
option/str
replace/bool//false
section/str
set_find/bool//true
type/str
unique/bool//false
value/any
"
RESPONSE_VARS="result=_result command config section option"
init() {
state_path=""
[ -z "$_ansible_check_mode" ] || state_path="$(mktemp -d)" ||
fail "could not create state path"
changes="$(uci_change_hash)"
case "$_type_keep_keys" in
object) fail "keep_keys must be list or string";;
array) json_get_values keep_keys "$_keep_keys" || :;;
esac
[ -z "$key" ] &&
key="${config:+$config${section:+.$section${option:+.$option}}}" ||
{ oIFS="$IFS"; IFS="."; set -- $key; IFS="$oIFS"
config="$1"; section="$2"; option="$3"; }
[ -z "$_ansible_diff" -o -z "$config" ] ||
set_diff "$(uci export "$config")"
[ -n "$command" ] || { [ -z "$value" ] && command="get" || command="set"; }
}
uci() {
[ -z "$state_path" ] || set -- -P "$state_path" "$@"
command uci "$@"
}
uci_change_hash() {
uci changes | md5
}
uci_result_do() {
json_set_namespace result
"$@"
json_set_namespace params
}
uci_get_safe() {
local tmp opts
while [ "${1#-}" != "$1" ]; do opts="$opts $1"; shift; done
tmp="$(uci $opts show "$1")" || return $?
echo "${tmp#*=}"
}
uci_check_type() {
local key="$1"; local type="$2"; local t
t="$(uci -q get "$key")" || return 1
[ -n "$type" -a "$t" != "$type" ] || return 0
fail "$key exists with $t instead of $type"
}
uci_compare_list() {
local k="${1:-$key}"
local match="1"
local keys values v i
json_get_keys keys
! values="$(uci_get_safe -q "$k")" || {
eval "set -- $values"
for i in $keys; do
json_get_var v "$i"
[ $# -gt 0 -a "$v" = "$1" ] || { match=""; break; }
shift
done
[ $# -eq 0 ] || match=""
[ -z "$match" ] || return 0
}
return 1
}
uci_add() {
section="${section:-$value}"
[ -n "$name" -o -z "$type" ] || name="$section"
type="${type:-$section}"
[ -n "$type" ] || fail "type required for $command"
[ -n "$name" ] && {
uci_check_type "$config.$name" "$type" || {
try uci add "$config" "$type"
try uci rename "$config.$_result=$name"
}
} || try uci add "$config" "$type"
}
uci_set_list() {
local k="${1:-$key}"
local keys v i
! uci_compare_list "$k" || return 0
uci -q delete "$k" || :
json_get_keys keys
for i in $keys; do
json_get_var v "$i"
try uci add_list "$k=$v"
done
}
uci_set_dict() {
local keys k v t
json_get_keys keys
keep_keys="$keep_keys $keys"
for k in $keys; do
json_get_type t "$k"
case "$t" in
array)
json_select "$k"
uci_set_list "$key.$k"
json_select ..;;
object) fail "cannot set $k to dict";;
*)
json_get_var v "$k"
try uci set "$key.$k=$v";;
esac
done
}
uci_set() {
local var="${1:-value}"
local var_type
eval "var_type=\"\$_type_$var\""
[ -z "$option" ] || keep_keys="$keep_keys $option"
case "$var_type" in
array)
[ -n "$config" -a -n "$section" -a -n "$option" ] ||
fail "config, section and option required for $command"
json_select_real "$var"
uci_set_list
json_select ..;;
object)
[ -n "$config" -a -n "$section" -a -z "$option" ] ||
fail "config and section but not option required for $command"
json_select_real "$var"
uci_set_dict
json_select ..;;
*) try "uci set \"\$key=\$$var\"";;
esac
}
uci_get() {
local entry
try uci get "$key"
eval "set -- $(uci_get_safe -q "$key")"
json_set_namespace result
json_add_array result_list
for entry; do json_add_string . "$entry"; done
json_close_array
json_set_namespace params
}
uci_find() {
local keys i c v k tmp
case "$_type_find" in
array|object)
[ -n "$config" -a -n "$type" ] ||
fail "config and type required for $command"
json_select_real find
json_get_keys keys;;
*)
[ -n "$config" -a -n "$type" ] &&
[ -n "$option" -o "$command" = find_all ] ||
fail "config, type and option required for $command";;
esac
[ "$command" != "find_all" ] || uci_result_do json_add_array result
type="${type:-$section}"
section=""; i=0
while [ -n "$(uci -q get "$config.@$type[$i]")" ]; do
c="@$type[$((i++))]"
case "$_type_find" in
array)
[ -z "$option" ] && {
for k in $keys; do
json_get_var v "$k"
uci -q get "$config.$c.$v" >/dev/null || continue 2
done
} || {
uci_compare_list "$config.$c.$option" || continue
};;
object)
for k in $keys; do
json_get_type tmp "$k"
case "$tmp" in
array)
json_select "$k"
uci_compare_list "$config.$c.$k" &&
tmp="1" || tmp=""
json_select ..
[ -n "$tmp" ] || continue 2;;
object)
fail "cannot compare $k with dict";;
*)
json_get_var v "$k"
tmp="$(uci -q get "$config.$c.$k")" &&
[ "$tmp" = "$v" ] || continue 2
esac
done;;
*)
[ -z "$option" ] || {
v="$(uci -q get "$config.$c.$option")" &&
[ -z "$find" -o "$find" = "$v" ] || continue
};;
esac
[ "$command" = "find_all" ] || { section="$c"; break; }
uci_result_do json_add_string . "$c"
done
case "$_type_find" in
array|object) json_select ..;;
esac
case "$command" in
find_all)
uci_result_do json_close_array
_result="";;
*)
_result="$section"
[ -n "$section" ] && return 0 || return 1;;
esac
}
uci_ensure() {
local keys k v
[ -n "$name" -o -z "$type" ] || name="$section"
type="${type:-$section}"
[ -n "$config" -a -n "$type" ] ||
fail "config, type and name required for $command"
[ -n "$name" ] && uci_check_type "$config.$name" "$type" || {
[ "$_type_find" = "object" -o -n "$option" ] && uci_find && {
[ -z "$name" ] || try uci rename "$config.$section=$name"
} || {
[ "$command" = absent ] && return 0 || uci_add
}
}
section="${name:-$_result}"
key="$config.$section${option:+.$option}"
[ "$command" = "absent" ] && {
[ -z "$_defined_value" ] &&
{ uci -q delete "$key" || :; } ||
case "$_type_value" in
array|object)
json_select_real value
json_get_keys keys
for k in $keys; do
json_get_var v "$k"
case "$_type_value" in
array) uci -q delete "$config.$section.$v";;
object) uci -q delete "$config.$section.$k=$v";;
esac
done
json_select ..;;
*) uci -q delete "$config.$section.$value";;
esac
return 0
}
[ -z "$set_find" -o "$_type_find" != "object" -a -z "$option" ] || {
uci_set find
[ "$_type_value" != "object" ] || {
key="$config.$section"
option=""
}
}
[ -z "$_defined_value" ] || uci_set
_result="$section"
}
uci_cleanup_section() {
case "$command" in
set|ensure|section) :;;
*) return 0;;
esac
local k v
[ -n "$replace" -a -n "$config" -a -n "$section" ] || return 0
for k in $(uci -q show "$config.$section" |
sed -n 's/^..*\...*\.\([^.][^.]*\)=.*$/\1/p')
do
for v in $keep_keys; do
[ "$k" != "$v" ] || continue 2
done
uci -q delete "$config.$section.$k"
done
}
uci_revert() {
[ -z "$key" ] && rm -f -- "/tmp/.uci"/* 2>/dev/null || uci revert "$key"
}
uci_autocommit() {
[ -n "$autocommit" ] || return 0
case "$command" in
commit|revert) return 0;;
esac
[ "$1" -eq 0 ] && {
[ -n "$config" ] && uci commit "$config" || uci commit
} || uci_revert
}
main() {
case "$command" in
batch|import)
[ -n "$value" ] || fail "value required for $command";;
add_list|del_list|rename|reorder)
[ -n "$key" -a -n "$value" ] ||
fail "key and value required for $command";;
add|get|delete|ensure|absent)
[ -n "$key" ] || fail "key required for $command";;
esac
case "$command" in
batch)
echo "$value" | final uci $command;;
export|changes|show|commit)
local cmd="final uci $command"
[ -z "$key" ] && $cmd || $cmd "$key";;
import)
local cmd="final uci ${merge:+-m }$command"
[ -z "$key" ] && echo "$value" | $cmd ||
echo "$value" | $cmd "$key";;
add)
uci_add; exit 0;;
add_list)
[ -z "$unique" ] || {
eval "set -- $(uci_get_safe -q "$key")"
for entry; do [ "$entry" = "$value" ] && exit 0; done
}
final uci add_list "$key=$value";;
del_list|reorder)
final uci $command "$key=$value";;
get)
uci_get; exit 0;;
delete)
final uci $command "$key${value:+=$value}";;
rename)
final uci $command "$key=${name:-$value}";;
revert)
final uci_revert;;
set)
uci_set; exit 0;;
find|find_all)
uci_find; exit $?;;
ensure|section)
uci_ensure; exit 0;;
absent)
[ -n "$_defined_find" ] || {
uci -q delete "$key${value:+=$value}"; exit 0
}
uci_ensure; exit 0;;
*) fail "unknown command: $command";;
esac
}
cleanup() {
local ec="$1"
[ "$ec" -ne 0 ] || uci_cleanup_section
[ "$changes" = "$(uci_change_hash)" ] || {
changed
[ "$_ansible_verbosity" -lt 2 ] || {
local _IFS line
_IFS="$IFS"; IFS="$N"; set -- $(uci changes); IFS="$_IFS"
json_set_namespace result
json_add_array changes
for line; do json_add_string . "$line"; done
json_close_array
json_set_namespace params
}
uci_autocommit "$ec"
}
[ -z "$_ansible_diff" -o -z "$config" ] ||
set_diff "" "$(uci export "$config")"
[ -z "$_ansible_check_mode" -o -z "$state_path" -o ! -d "$state_path" ] ||
rm -rf "$state_path"
}

View File

@@ -0,0 +1,190 @@
#!/usr/bin/python
# Copyright (c) 2017 Markus Weippert
# GNU General Public License v3.0 (see https://www.gnu.org/licenses/gpl-3.0.txt)
ANSIBLE_METADATA = {
'metadata_version': '1.0',
'status': ['preview'],
'supported_by': '@gekmihesg'
}
DOCUMENTATION = '''
---
module: uci
short_description: Controls OpenWRTs UCI
description:
- The M(uci) module is a Ansible wrapper for OpenWRTs C(uci).
- It supports all the command line functionality plus some extra commands.
author: Markus Weippert (@gekmihesg)
options:
autocommit:
description:
- Whether to automatically commit changes
type: bool
default: false
command:
description:
- Command to execute. Execution takes place in a shell.
default: set if value else get
choices:
- absent
- add
- add_list
- batch
- changes
- commit
- del_list
- export
- find
- get
- import
- rename
- reorder
- revert
- section
- set
- show
aliases:
- cmd
config:
description:
- Config part of the I(key).
default: extracted from I(key)
find:
description:
- Value(s) to match sections against.
- Option value to find if I(option) is set. May be list.
- Dict of options/values if I(option) is not set. Values may be list.
- Lists are compared in order.
- Required when I(command=find) or I(command=section)
aliases:
- find_by
- search
keep_keys:
description:
- Space seperated list or list of keys not in I(value) or I(find) to
keep when I(replace=yes).
aliases:
- keep
key:
description:
- The C(uci) key to operate on.
- Takes precedence over I(config), I(section) and I(option)
default: I(config).I(section).I(option)
merge:
description:
- Whether to merge or replace when I(command=import)
type: bool
default: false
name:
description:
- New name when I(command=rename) or I(command=add).
- Desired name when I(command=section). If a matching section is
found it is renamed, if not it is created with that name.
option:
description:
- Option part of the I(key).
default: extracted from I(key)
replace:
description:
- When I(command=set) or I(command=section), whether to delete all
options not mentioned in I(keep_keys), I(value) or find when
I(set_find=true).
type: bool
default: false
section:
description:
- Section part of the I(key).
default: extracted from I(key)
set_find:
description:
- When I(command=section) whether to set the options used to search
a matching section in the newly created section when no match was
found.
type: bool
default: false
type:
description:
- Section type for I(command=section), I(command=find) and
I(command=add).
default: I(section)
unique:
description:
- When I(command=add_list), whether to add the value if it is already
contained in the list.
type: bool
default: false
value:
description:
- The value for various commands.
'''
EXAMPLES = '''
# Find a section of type wifi-iface with matching name or matching attributes.
# If not found create it and set the attributes from find.
# Unconditionally set the attributes from value and delete all other options.
- uci:
command: section
config: wireless
type: wifi-iface
name: ap0
find:
device: radio0
ssid: My SSID
value:
encryption: none
replace: yes
# Find a matching wifi-iface and delete it.
- uci:
command: absent
config: wireless
type: wifi-iface
find:
ssid: My SSID broken
# Find a matching wifi-iface and delete the options key and encryption.
- uci:
command: absent
config: wireless
type: wifi-iface
find:
ssid: My SSID public
value:
- key
- encryption
# commit changes and notify
- uci: cmd=commit
notify: restart wifi
'''
RETURN = '''
result:
description: output of the C(uci) command
returned: always
type: string
sample: cfg12523
result_list:
description: the list form of result
returned: when I(command=get)
type: list of string
sample: ['0.pool.ntp.org','1.pool.ntp.org']
config:
description: config part of I(key)
returned: when given
type: string
sample: wireless
section:
description: section part of I(key)
returned: when given
type: string
sample: '@wifi-iface[0]'
option:
description: option part of I(key)
returned: when given
type: string
sample: ssid
command:
description: command executed
returned: always
type: string
sample: section
'''

View File

@@ -0,0 +1,2 @@
install_date: 'Sun 07 Jul 2024 02:07:36 PM '
version: master

View File

@@ -0,0 +1,27 @@
---
galaxy_info:
namespace: gekmihesg
role_name: openwrt
author: Markus Weippert
description: Manage OpenWRT without python
issue_tracker_url: https://github.com/gekmihesg/ansible-openwrt/issues
license: GPL-3.0
min_ansible_version: '2.4'
platforms:
- name: GenericLinux
# platforms:
# - name: LEDE
# versions:
# - 17.01
# - name: OpenWRT
# versions:
# - 15.05
galaxy_tags:
- busybox
- lede
- openwrt
- shell
- uci
dependencies: []
# code: language=yaml tabSize=2

View File

@@ -0,0 +1,3 @@
---
collections:
- community.general

View File

@@ -0,0 +1,11 @@
---
- name: Converge
hosts: all
gather_facts: false
tasks:
- name: "Create /var/lock"
ansible.builtin.raw: "mkdir -p /var/lock"
changed_when: false
- name: "Include gekmihesg.openwrt"
ansible.builtin.include_role:
name: "gekmihesg.openwrt"

View File

@@ -0,0 +1,45 @@
---
dependency:
name: galaxy
requirements-file: collections.yml
driver:
name: docker
platforms:
- name: instance_latest
image: openwrtorg/rootfs:latest
command: sleep infinity
pre_build_image: true
groups:
- openwrt
- name: instance_x86_64-22.03.2
image: openwrtorg/rootfs:x86_64-22.03.2
command: sleep infinity
pre_build_image: true
groups:
- openwrt
- name: instance_x86_64-21.02.5
image: openwrtorg/rootfs:x86_64-21.02.5
command: sleep infinity
pre_build_image: true
groups:
- openwrt
- name: instance_x86_64-19.07.10
image: openwrtorg/rootfs:x86_64-19.07.10
command: "sh -c 'while true; do sleep 10000; done'"
pre_build_image: true
groups:
- openwrt
- name: instance_x86-64-18.06.6
image: openwrtorg/rootfs:x86-64-18.06.6
command: "sh -c 'while true; do sleep 10000; done'"
pre_build_image: true
groups:
- openwrt
provisioner:
name: ansible
verifier:
name: ansible
lint: |
set -e
yamllint .
ansible-lint .

View File

@@ -0,0 +1,49 @@
---
# This is an example playbook to execute Ansible tests.
- name: Verify
hosts: all
gather_facts: false
roles:
- gekmihesg.openwrt
vars:
openwrt_install_recommended_packages: false
tasks:
- name: Retrieve /etc/os-release
slurp:
src: /etc/os-release
register: os_release_slurp
- name: Populate fact os_release
ansible.builtin.set_fact:
os_release: >-
{{
_os_release_dict.keys() | map('lower')
| zip(_os_release_dict.values())
| items2dict(key_name=0, value_name=1)
}}
vars:
_os_release_lines: "{{ os_release_slurp['content'] | b64decode | split('\n') }}"
_os_release_split: "{{ _os_release_lines | map('regex_search', '^([A-Z_0-9]+)=\"(.*)\"$', '\\1', '\\2') | reject('none') }}"
_os_release_dict: "{{ dict(_os_release_split) }}"
- name: Run simple command
command:
cmd: "echo Holy canole, it\\'s {{ os_release.name }}"
register: holy_canole
- name: Assert Canole
ansible.builtin.assert:
that:
- holy_canole.stdout.startswith("Holy canole, it's OpenWrt")
- name: Read UCI
uci:
command: get
key: network.wan.ifname
register: uci_wan_ifname
- name: Assert WAN network interface name (UCI)
ansible.builtin.assert:
that:
- uci_wan_ifname.result == "eth0"

View File

@@ -0,0 +1,4 @@
molecule[docker,lint]
docker
yamllint
ansible-lint

View File

@@ -0,0 +1,20 @@
---
- name: pin defaults
set_fact:
openwrt_ssh: "{{ openwrt_ssh }}"
openwrt_scp: "{{ openwrt_scp }}"
openwrt_ssh_user: "{{ openwrt_ssh_user }}"
openwrt_ssh_host: "{{ openwrt_ssh_host }}"
openwrt_user_host: "{{ openwrt_ssh_user | quote }}@{{ openwrt_ssh_host | quote }}"
ansible_ssh_transfer_method: "{{ openwrt_ssh_transfer_method }}"
ansible_ssh_use_tty: "{{ openwrt_ssh_use_tty }}"
ansible_scp_if_ssh: "{{ openwrt_scp_if_ssh }}"
ansible_remote_tmp: "{{ openwrt_remote_tmp }}"
when: "'openwrt' in group_names"
tags: always
- name: install recommended packages
include_tasks: packages.yml
when:
- "'openwrt' in group_names"
- "openwrt_install_recommended_packages | bool"

View File

@@ -0,0 +1,12 @@
---
- name: "check for command {{ item.key }}"
command: "which {{ item.key | quote }}"
register: _package
check_mode: false
changed_when: false
failed_when: false
- name: "install {{ item.value }} to provide {{ item.key }}"
opkg:
name: "{{ item.value }}"
when: _package.rc

View File

@@ -0,0 +1,40 @@
---
- name: check whether opkg caches need update
stat:
path: "{{ openwrt_remote_opkg_lists_dir }}"
register: _opkg_lists
- name: get current system time
command: date +%s
register: _epoch
check_mode: false
changed_when: false
when: _opkg_lists.stat.exists
- name: update opkg cache
opkg:
name: opkg
update_cache: true
register: _update
when: not _opkg_lists.stat.exists or
_epoch.stdout|int - _opkg_lists.stat.mtime > 86400
failed_when: not _opkg_lists.stat.exists and _update.failed
changed_when: not _update.failed
- name: check for openssl
command: which openssl
register: _openssl
check_mode: false
changed_when: false
failed_when: false
- include_tasks: package.yml
with_dict:
base64: coreutils-base64
md5sum: coreutils-md5sum
sha1sum: coreutils-sha1sum
when: _openssl.rc
- name: avoid re-checking of packages
set_fact:
openwrt_install_recommended_packages: false

View File

@@ -0,0 +1,51 @@
import os
from ansible.plugins.action import ActionBase
from ansible.plugins.vars import BaseVarsPlugin
try:
from ansible.utils.collection_loader import resource_from_fqcr
except ImportError:
resource_from_fqcr = lambda x: x
def _fix_module_args(module_args):
for k, v in module_args.items():
if v is None:
module_args[k] = False
elif isinstance(v, dict):
_fix_module_args(v)
elif isinstance(v, list):
module_args[k] = [False if i is None else i for i in v]
def _configure_module(self, module_name, module_args, task_vars=None):
if task_vars is None:
task_vars = dict()
if self._task.delegate_to:
real_vars = task_vars.get('ansible_delegated_vars', dict()).get(self._task.delegate_to, dict())
else:
real_vars = task_vars
if real_vars.get('ansible_connection', '') not in ('local',) and \
'openwrt' in real_vars.get('group_names', list()):
leaf_module_name = resource_from_fqcr(module_name)
openwrt_module = self._shared_loader_obj.module_loader.find_plugin('openwrt_' + leaf_module_name, '.sh')
if openwrt_module:
module_name = os.path.basename(openwrt_module)[:-3]
else:
openwrt_module = None
(module_style, module_shebang, module_data, module_path) = \
self.__configure_module(module_name, module_args, task_vars)
if openwrt_module:
with open(_wrapper_file, 'r') as f:
wrapper_data = f.read()
if type(module_data) is bytes:
module_data = module_data.decode()
module_data = wrapper_data.replace('\n. "$_script"\n', '\n' + module_data + '\n')
_fix_module_args(module_args)
return (module_style, module_shebang, module_data, module_path)
if ActionBase._configure_module != _configure_module:
_wrapper_file = os.path.join(os.path.dirname(__file__), '..', 'files', 'wrapper.sh')
ActionBase.__configure_module = ActionBase._configure_module
ActionBase._configure_module = _configure_module
class VarsModule(BaseVarsPlugin):
def get_vars(*args, **kwargs):
return dict()